/**
 * @file main.cpp
 * @brief 
 */


#include <stdexcept>

#include "TSPSolver.h"

// error status and messagge buffer
int status;
char errmsg[255];


int main (int argc, char const *argv[])
{
  try
  {
    if (argc < 4) throw std::runtime_error("usage: ./main filename.dat tabulength maxiter");  /// new parameters for TS
		int tabuLength = atoi(argv[2]);                                                           /// new parameters for TS
		int maxIter    = atoi(argv[3]);                                                           /// new parameters for TS
    TSP tspInstance;
    tspInstance.read(argv[1]);
    TSPSolution aSolution(tspInstance);
    TSPSolver tspSolver;
    tspSolver.initRnd(aSolution);

    TSPSolution bestSolution(tspInstance);
    tspSolver.solve(tspInstance,aSolution,tabuLength,maxIter,bestSolution);                   /// new parameters for TS

    std::cout << "FROM solution: "; 
    aSolution.print();
    std::cout << "(value : " << tspSolver.evaluate(aSolution,tspInstance) << ")\n";
    std::cout << "TO   solution: "; 
    bestSolution.print();
    std::cout << "(value : " << tspSolver.evaluate(bestSolution,tspInstance) << ")\n";
    
  }
  catch(std::exception& e)
  {
    std::cout << ">>>EXCEPTION: " << e.what() << std::endl;
  }
  return 0;
}
